Add logrotate example
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Helper values for calling builtin functions
13 empty :=
14 space := $(empty) $(empty)
15 comma := ,
16
17 # Helper function to strip src/ and test/hs/ from a list
18 strip_hsroot = $(patsubst src/%,%,$(patsubst test/hs/%,%,$(1)))
19
20 # Use bash in order to be able to use pipefail
21 SHELL=/bin/bash
22
23 ACLOCAL_AMFLAGS = -I autotools
24 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
25 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
26 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
27 CHECK_HEADER = $(top_srcdir)/autotools/check-header
28 CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
29 CHECK_MAN_REFERENCES = $(top_srcdir)/autotools/check-man-references
30 CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
31 CHECK_VERSION = $(top_srcdir)/autotools/check-version
32 CHECK_NEWS = $(top_srcdir)/autotools/check-news
33 CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
34 DOCPP = $(top_srcdir)/autotools/docpp
35 REPLACE_VARS_SED = autotools/replace_vars.sed
36 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
37 BUILD_RPC = $(top_srcdir)/autotools/build-rpc
38 SHELL_ENV_INIT = autotools/shell-env-init
39
40 # Note: these are automake-specific variables, and must be named after
41 # the directory + 'dir' suffix
42 clientdir = $(pkgpythondir)/client
43 hypervisordir = $(pkgpythondir)/hypervisor
44 httpdir = $(pkgpythondir)/http
45 masterddir = $(pkgpythondir)/masterd
46 confddir = $(pkgpythondir)/confd
47 rapidir = $(pkgpythondir)/rapi
48 serverdir = $(pkgpythondir)/server
49 watcherdir = $(pkgpythondir)/watcher
50 impexpddir = $(pkgpythondir)/impexpd
51 utilsdir = $(pkgpythondir)/utils
52 toolsdir = $(pkglibdir)/tools
53 iallocatorsdir = $(pkglibdir)/iallocators
54 pytoolsdir = $(pkgpythondir)/tools
55 docdir = $(datadir)/doc/$(PACKAGE)
56 myexeclibdir = $(pkglibdir)
57
58 # Delete output file if an error occurred while building it
59 .DELETE_ON_ERROR:
60
61 HS_DIRS = \
62         src \
63         src/Ganeti \
64         src/Ganeti/Block \
65         src/Ganeti/Block/Drbd \
66         src/Ganeti/Confd \
67         src/Ganeti/DataCollectors \
68         src/Ganeti/HTools \
69         src/Ganeti/HTools/Backend \
70         src/Ganeti/HTools/Program \
71         src/Ganeti/Query \
72         test/hs \
73         test/hs/Test \
74         test/hs/Test/Ganeti \
75         test/hs/Test/Ganeti/Block \
76         test/hs/Test/Ganeti/Block/Drbd \
77         test/hs/Test/Ganeti/Confd \
78         test/hs/Test/Ganeti/HTools \
79         test/hs/Test/Ganeti/HTools/Backend \
80         test/hs/Test/Ganeti/Query
81
82 # Haskell directories without the roots (src, test/hs)
83 HS_DIRS_NOROOT = $(filter-out src,$(filter-out test/hs,$(HS_DIRS)))
84
85 DIRS = \
86         $(HS_DIRS) \
87         autotools \
88         daemons \
89         devel \
90         doc \
91         doc/css \
92         doc/examples \
93         doc/examples/gnt-debug \
94         doc/examples/hooks \
95         test/data/htools \
96         test/data/htools/rapi \
97         test/hs/shelltests \
98         lib \
99         lib/build \
100         lib/client \
101         lib/confd \
102         lib/http \
103         lib/hypervisor \
104         lib/impexpd \
105         lib/masterd \
106         lib/rapi \
107         lib/server \
108         lib/tools \
109         lib/utils \
110         lib/watcher \
111         man \
112         qa \
113         test \
114         test/data \
115         test/data/bdev-rbd \
116         test/data/ovfdata \
117         test/data/ovfdata/other \
118         test/py \
119         tools
120
121 ALL_APIDOC_HS_DIRS = \
122         $(APIDOC_HS_DIR) \
123         $(patsubst %,$(APIDOC_HS_DIR)/%,$(call strip_hsroot,$(HS_DIRS_NOROOT)))
124
125 BUILDTIME_DIR_AUTOCREATE = \
126         scripts \
127         $(APIDOC_DIR) \
128         $(ALL_APIDOC_HS_DIRS) \
129         $(APIDOC_PY_DIR) \
130         $(COVERAGE_DIR) \
131         $(COVERAGE_HS_DIR) \
132         $(COVERAGE_PY_DIR) \
133         .hpc
134
135 BUILDTIME_DIRS = \
136         $(BUILDTIME_DIR_AUTOCREATE) \
137         doc/html \
138         doc/man-html
139
140 DIRCHECK_EXCLUDE = \
141         $(BUILDTIME_DIRS) \
142         ganeti-[0-9]*.[0-9]*.[0-9]* \
143         doc/html/_* \
144         doc/man-html/_* \
145         autom4te.cache
146
147 # some helper vars
148 COVERAGE_DIR = doc/coverage
149 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
150 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
151 APIDOC_DIR = doc/api
152 APIDOC_PY_DIR = $(APIDOC_DIR)/py
153 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
154
155 MAINTAINERCLEANFILES = \
156         $(maninput) \
157         doc/install-quick.rst \
158         doc/news.rst \
159         doc/upgrade.rst \
160         vcs-version
161
162 maintainer-clean-local:
163         rm -rf $(BUILDTIME_DIRS)
164
165 CLEANFILES = \
166         $(addsuffix /*.py[co],$(DIRS)) \
167         $(addsuffix /*.hi,$(HS_DIRS)) \
168         $(addsuffix /*.o,$(HS_DIRS)) \
169         $(PYTHON_BOOTSTRAP) \
170         epydoc.conf \
171         $(REPLACE_VARS_SED) \
172         $(SHELL_ENV_INIT) \
173         daemons/daemon-util \
174         daemons/ganeti-cleaner \
175         $(mandocrst) \
176         doc/manpages-enabled.rst \
177         $(BUILT_EXAMPLES) \
178         doc/examples/bash_completion \
179         doc/examples/bash_completion-debug \
180         lib/_generated_rpc.py \
181         $(man_MANS) \
182         $(manhtml) \
183         tools/kvm-ifup \
184         tools/users-setup \
185         tools/vcluster-setup \
186         stamp-directories \
187         stamp-srclinks \
188         $(nodist_pkgpython_PYTHON) \
189         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
190         $(HS_BUILT_TEST_HELPERS) \
191         src/ganeti-confd \
192         .hpc/*.mix src/*.tix test/hs/*.tix \
193         doc/hs-lint.html
194
195 GENERATED_FILES = \
196         $(built_base_sources) \
197         $(BUILT_PYTHON_SOURCES) \
198         $(PYTHON_BOOTSTRAP)
199
200 HS_GENERATED_FILES =
201 if WANT_HTOOLS
202 HS_GENERATED_FILES += $(HS_PROGS)
203 if ENABLE_CONFD
204 HS_GENERATED_FILES += src/hconfd src/ganeti-confd
205 endif
206 endif
207
208 built_base_sources = \
209         stamp-directories \
210         stamp-srclinks
211
212 built_python_base_sources = \
213         lib/_autoconf.py \
214         lib/_vcsversion.py
215
216 BUILT_PYTHON_SOURCES = \
217         $(built_python_base_sources) \
218         lib/_generated_rpc.py
219
220 # Generating the RPC wrappers depends on many things, so make sure
221 # it's built at the end of the built sources
222 lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
223
224 # these are all built from the underlying %.in sources
225 BUILT_EXAMPLES = \
226         doc/examples/ganeti-kvm-poweroff.initd \
227         doc/examples/ganeti.cron \
228         doc/examples/ganeti.initd \
229         doc/examples/ganeti.logrotate \
230         doc/examples/ganeti-master-role.ocf \
231         doc/examples/ganeti-node-role.ocf \
232         doc/examples/gnt-config-backup \
233         doc/examples/hooks/ipsec
234
235 nodist_pkgpython_PYTHON = \
236         $(BUILT_PYTHON_SOURCES)
237
238 noinst_PYTHON = \
239         lib/build/__init__.py \
240         lib/build/shell_example_lexer.py \
241         lib/build/sphinx_ext.py
242
243 pkgpython_PYTHON = \
244         lib/__init__.py \
245         lib/asyncnotifier.py \
246         lib/backend.py \
247         lib/bdev.py \
248         lib/bootstrap.py \
249         lib/cli.py \
250         lib/cmdlib.py \
251         lib/compat.py \
252         lib/config.py \
253         lib/constants.py \
254         lib/daemon.py \
255         lib/errors.py \
256         lib/hooksmaster.py \
257         lib/ht.py \
258         lib/jqueue.py \
259         lib/jstore.py \
260         lib/locking.py \
261         lib/luxi.py \
262         lib/mcpu.py \
263         lib/netutils.py \
264         lib/objects.py \
265         lib/opcodes.py \
266         lib/outils.py \
267         lib/ovf.py \
268         lib/pathutils.py \
269         lib/qlang.py \
270         lib/query.py \
271         lib/rpc.py \
272         lib/rpc_defs.py \
273         lib/runtime.py \
274         lib/serializer.py \
275         lib/ssconf.py \
276         lib/ssh.py \
277         lib/storage.py \
278         lib/uidpool.py \
279         lib/vcluster.py \
280         lib/network.py \
281         lib/workerpool.py
282
283 client_PYTHON = \
284         lib/client/__init__.py \
285         lib/client/gnt_backup.py \
286         lib/client/gnt_cluster.py \
287         lib/client/gnt_debug.py \
288         lib/client/gnt_group.py \
289         lib/client/gnt_instance.py \
290         lib/client/gnt_job.py \
291         lib/client/gnt_node.py \
292         lib/client/gnt_network.py \
293         lib/client/gnt_os.py \
294         lib/client/gnt_storage.py
295
296 hypervisor_PYTHON = \
297         lib/hypervisor/__init__.py \
298         lib/hypervisor/hv_base.py \
299         lib/hypervisor/hv_chroot.py \
300         lib/hypervisor/hv_fake.py \
301         lib/hypervisor/hv_kvm.py \
302         lib/hypervisor/hv_lxc.py \
303         lib/hypervisor/hv_xen.py
304
305 rapi_PYTHON = \
306         lib/rapi/__init__.py \
307         lib/rapi/baserlib.py \
308         lib/rapi/client.py \
309         lib/rapi/client_utils.py \
310         lib/rapi/connector.py \
311         lib/rapi/rlib2.py \
312         lib/rapi/testutils.py
313
314 http_PYTHON = \
315         lib/http/__init__.py \
316         lib/http/auth.py \
317         lib/http/client.py \
318         lib/http/server.py
319
320 confd_PYTHON = \
321         lib/confd/__init__.py \
322         lib/confd/client.py
323
324 masterd_PYTHON = \
325         lib/masterd/__init__.py \
326         lib/masterd/iallocator.py \
327         lib/masterd/instance.py
328
329 impexpd_PYTHON = \
330         lib/impexpd/__init__.py
331
332 watcher_PYTHON = \
333         lib/watcher/__init__.py \
334         lib/watcher/nodemaint.py \
335         lib/watcher/state.py
336
337 server_PYTHON = \
338         lib/server/__init__.py \
339         lib/server/masterd.py \
340         lib/server/noded.py \
341         lib/server/rapi.py
342
343 pytools_PYTHON = \
344         lib/tools/__init__.py \
345         lib/tools/burnin.py \
346         lib/tools/ensure_dirs.py \
347         lib/tools/node_cleanup.py \
348         lib/tools/node_daemon_setup.py \
349         lib/tools/prepare_node_join.py
350
351 utils_PYTHON = \
352         lib/utils/__init__.py \
353         lib/utils/algo.py \
354         lib/utils/filelock.py \
355         lib/utils/hash.py \
356         lib/utils/io.py \
357         lib/utils/log.py \
358         lib/utils/lvm.py \
359         lib/utils/mlock.py \
360         lib/utils/nodesetup.py \
361         lib/utils/process.py \
362         lib/utils/retry.py \
363         lib/utils/text.py \
364         lib/utils/wrapper.py \
365         lib/utils/x509.py
366
367 docinput = \
368         doc/conf.py \
369         doc/css/style.css \
370         doc/admin.rst \
371         doc/cluster-merge.rst \
372         doc/design-2.0.rst \
373         doc/design-2.1.rst \
374         doc/design-2.2.rst \
375         doc/design-2.3.rst \
376         doc/design-2.4.rst \
377         doc/design-2.5.rst \
378         doc/design-2.6.rst \
379         doc/design-2.7.rst \
380         doc/design-autorepair.rst \
381         doc/design-bulk-create.rst \
382         doc/design-chained-jobs.rst \
383         doc/design-cpu-pinning.rst \
384         doc/design-draft.rst \
385         doc/design-htools-2.3.rst \
386         doc/design-http-server.rst \
387         doc/design-impexp2.rst \
388         doc/design-lu-generated-jobs.rst \
389         doc/design-linuxha.rst \
390         doc/design-multi-reloc.rst \
391         doc/design-network.rst \
392         doc/design-node-add.rst \
393         doc/design-oob.rst \
394         doc/design-ovf-support.rst \
395         doc/design-opportunistic-locking.rst \
396         doc/design-partitioned.rst \
397         doc/design-query-splitting.rst \
398         doc/design-query2.rst \
399         doc/design-resource-model.rst \
400         doc/design-restricted-commands.rst \
401         doc/design-shared-storage.rst \
402         doc/design-monitoring-agent.rst \
403         doc/design-virtual-clusters.rst \
404         doc/design-x509-ca.rst \
405         doc/devnotes.rst \
406         doc/glossary.rst \
407         doc/hooks.rst \
408         doc/iallocator.rst \
409         doc/index.rst \
410         doc/install-quick.rst \
411         doc/install.rst \
412         doc/locking.rst \
413         doc/manpages-disabled.rst \
414         doc/move-instance.rst \
415         doc/news.rst \
416         doc/ovfconverter.rst \
417         doc/rapi.rst \
418         doc/security.rst \
419         doc/upgrade.rst \
420         doc/virtual-cluster.rst \
421         doc/walkthrough.rst
422
423 # Generates file names such as "doc/man-gnt-instance.rst"
424 mandocrst = $(addprefix doc/man-,$(notdir $(manrst)))
425
426 # Haskell programs to be installed in $PREFIX/bin
427 HS_BIN_PROGS=src/htools
428
429 # Haskell programs to be installed in the MYEXECLIB dir
430 if ENABLE_MONITORING
431 HS_MYEXECLIB_PROGS=src/mon-collector
432 else
433 HS_MYEXECLIB_PROGS=
434 endif
435
436 # Haskell programs to compiled but not installed automatically
437 # Usually they have their own specific installation rules
438 HS_COMPILE_PROGS= \
439         src/hconfd \
440         src/rpc-test
441
442 # All Haskell non-test programs to be compiled but not automatically installed
443 HS_PROGS = $(HS_BIN_PROGS) $(HS_MYEXECLIB_PROGS)
444
445 HS_BIN_ROLES = hbal hscan hspace hinfo hcheck hroller
446 HS_HTOOLS_PROGS = $(HS_BIN_ROLES) hail
447
448 HS_ALL_PROGS = \
449         $(HS_PROGS) \
450         test/hs/hpc-htools \
451         test/hs/hpc-mon-collector \
452         test/hs/htest \
453         $(HS_COMPILE_PROGS)
454
455 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
456 HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=test/hs/%) test/hs/hail
457
458 HFLAGS = \
459         -O -Wall -Werror -isrc \
460         -fwarn-monomorphism-restriction \
461         -fwarn-tabs \
462         $(GHC_BYVERSION_FLAGS)
463
464 # extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
465 HEXTRA =
466 # internal extra flags (used for test/hs/htest mainly)
467 HEXTRA_INT =
468 # exclude options for coverage reports
469 HPCEXCL = --exclude Main \
470         --exclude Ganeti.Constants \
471         --exclude Ganeti.HTools.QC \
472         --exclude Ganeti.THH \
473         --exclude Ganeti.Version \
474         --exclude Test.Ganeti.Attoparsec \
475         --exclude Test.Ganeti.TestCommon \
476         --exclude Test.Ganeti.TestHTools \
477         --exclude Test.Ganeti.TestHelper \
478         --exclude Test.Ganeti.TestImports \
479         $(patsubst src.%,--exclude Test.%,$(subst /,.,$(patsubst %.hs,%, $(HS_LIB_SRCS))))
480
481 HS_LIB_SRCS = \
482         src/Ganeti/Block/Drbd/Types.hs \
483         src/Ganeti/Block/Drbd/Parser.hs \
484         src/Ganeti/BasicTypes.hs \
485         src/Ganeti/Common.hs \
486         src/Ganeti/Compat.hs \
487         src/Ganeti/Confd/Client.hs \
488         src/Ganeti/Confd/Server.hs \
489         src/Ganeti/Confd/Types.hs \
490         src/Ganeti/Confd/Utils.hs \
491         src/Ganeti/Config.hs \
492         src/Ganeti/Daemon.hs \
493         src/Ganeti/DataCollectors/CLI.hs \
494         src/Ganeti/DataCollectors/Drbd.hs \
495         src/Ganeti/DataCollectors/Program.hs \
496         src/Ganeti/DataCollectors/Types.hs \
497         src/Ganeti/Errors.hs \
498         src/Ganeti/HTools/Backend/IAlloc.hs \
499         src/Ganeti/HTools/Backend/Luxi.hs \
500         src/Ganeti/HTools/Backend/Rapi.hs \
501         src/Ganeti/HTools/Backend/Simu.hs \
502         src/Ganeti/HTools/Backend/Text.hs \
503         src/Ganeti/HTools/CLI.hs \
504         src/Ganeti/HTools/Cluster.hs \
505         src/Ganeti/HTools/Container.hs \
506         src/Ganeti/HTools/ExtLoader.hs \
507         src/Ganeti/HTools/Graph.hs \
508         src/Ganeti/HTools/Group.hs \
509         src/Ganeti/HTools/Instance.hs \
510         src/Ganeti/HTools/Loader.hs \
511         src/Ganeti/HTools/Node.hs \
512         src/Ganeti/HTools/PeerMap.hs \
513         src/Ganeti/HTools/Program/Hail.hs \
514         src/Ganeti/HTools/Program/Hbal.hs \
515         src/Ganeti/HTools/Program/Hcheck.hs \
516         src/Ganeti/HTools/Program/Hinfo.hs \
517         src/Ganeti/HTools/Program/Hscan.hs \
518         src/Ganeti/HTools/Program/Hspace.hs \
519         src/Ganeti/HTools/Program/Hroller.hs \
520         src/Ganeti/HTools/Program/Main.hs \
521         src/Ganeti/HTools/Types.hs \
522         src/Ganeti/Hash.hs \
523         src/Ganeti/JQueue.hs \
524         src/Ganeti/JSON.hs \
525         src/Ganeti/Jobs.hs \
526         src/Ganeti/Logging.hs \
527         src/Ganeti/Luxi.hs \
528         src/Ganeti/Network.hs \
529         src/Ganeti/Objects.hs \
530         src/Ganeti/OpCodes.hs \
531         src/Ganeti/OpParams.hs \
532         src/Ganeti/Path.hs \
533         src/Ganeti/Query/Common.hs \
534         src/Ganeti/Query/Filter.hs \
535         src/Ganeti/Query/Group.hs \
536         src/Ganeti/Query/Job.hs \
537         src/Ganeti/Query/Language.hs \
538         src/Ganeti/Query/Node.hs \
539         src/Ganeti/Query/Query.hs \
540         src/Ganeti/Query/Server.hs \
541         src/Ganeti/Query/Types.hs \
542         src/Ganeti/Rpc.hs \
543         src/Ganeti/Runtime.hs \
544         src/Ganeti/Ssconf.hs \
545         src/Ganeti/THH.hs \
546         src/Ganeti/Types.hs \
547         src/Ganeti/Utils.hs
548
549 HS_TEST_SRCS = \
550         test/hs/Test/Ganeti/Attoparsec.hs \
551         test/hs/Test/Ganeti/BasicTypes.hs \
552         test/hs/Test/Ganeti/Block/Drbd/Parser.hs \
553         test/hs/Test/Ganeti/Block/Drbd/Types.hs \
554         test/hs/Test/Ganeti/Common.hs \
555         test/hs/Test/Ganeti/Confd/Types.hs \
556         test/hs/Test/Ganeti/Confd/Utils.hs \
557         test/hs/Test/Ganeti/Daemon.hs \
558         test/hs/Test/Ganeti/Errors.hs \
559         test/hs/Test/Ganeti/HTools/Backend/Simu.hs \
560         test/hs/Test/Ganeti/HTools/Backend/Text.hs \
561         test/hs/Test/Ganeti/HTools/CLI.hs \
562         test/hs/Test/Ganeti/HTools/Cluster.hs \
563         test/hs/Test/Ganeti/HTools/Container.hs \
564         test/hs/Test/Ganeti/HTools/Graph.hs \
565         test/hs/Test/Ganeti/HTools/Instance.hs \
566         test/hs/Test/Ganeti/HTools/Loader.hs \
567         test/hs/Test/Ganeti/HTools/Node.hs \
568         test/hs/Test/Ganeti/HTools/PeerMap.hs \
569         test/hs/Test/Ganeti/HTools/Types.hs \
570         test/hs/Test/Ganeti/JSON.hs \
571         test/hs/Test/Ganeti/Jobs.hs \
572         test/hs/Test/Ganeti/JQueue.hs \
573         test/hs/Test/Ganeti/Luxi.hs \
574         test/hs/Test/Ganeti/Network.hs \
575         test/hs/Test/Ganeti/Objects.hs \
576         test/hs/Test/Ganeti/OpCodes.hs \
577         test/hs/Test/Ganeti/Query/Filter.hs \
578         test/hs/Test/Ganeti/Query/Language.hs \
579         test/hs/Test/Ganeti/Query/Query.hs \
580         test/hs/Test/Ganeti/Rpc.hs \
581         test/hs/Test/Ganeti/Runtime.hs \
582         test/hs/Test/Ganeti/Ssconf.hs \
583         test/hs/Test/Ganeti/THH.hs \
584         test/hs/Test/Ganeti/TestCommon.hs \
585         test/hs/Test/Ganeti/TestHTools.hs \
586         test/hs/Test/Ganeti/TestHelper.hs \
587         test/hs/Test/Ganeti/Types.hs \
588         test/hs/Test/Ganeti/Utils.hs
589
590 HS_LIBTEST_SRCS = $(HS_LIB_SRCS) $(HS_TEST_SRCS)
591
592 HS_BUILT_SRCS = \
593         test/hs/Test/Ganeti/TestImports.hs \
594         src/Ganeti/Constants.hs \
595         src/Ganeti/Version.hs
596 HS_BUILT_SRCS_IN = $(patsubst %,%.in,$(HS_BUILT_SRCS))
597
598 HS_LIBTESTBUILT_SRCS = $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS)
599
600 $(RUN_IN_TEMPDIR): | stamp-directories
601
602 doc/html/index.html: ENABLE_MANPAGES =
603 doc/man-html/index.html: ENABLE_MANPAGES = 1
604 doc/man-html/index.html: doc/manpages-enabled.rst $(mandocrst)
605
606 # Note: we use here an order-only prerequisite, as the contents of
607 # _autoconf.py are not actually influencing the html build output: it
608 # has to exist in order for the sphinx module to be loaded
609 # successfully, but we certainly don't want the docs to be rebuilt if
610 # it changes
611 doc/html/index.html doc/man-html/index.html: $(docinput) doc/conf.py \
612         configure.ac $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
613         lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
614         doc/css/style.css \
615         | $(BUILT_PYTHON_SOURCES)
616         @test -n "$(SPHINX)" || \
617             { echo 'sphinx-build' not found during configure; exit 1; }
618 if !MANPAGES_IN_DOC
619         if test -n '$(ENABLE_MANPAGES)'; then \
620           echo 'Man pages in documentation were disabled at configure time' >&2; \
621           exit 1; \
622         fi
623 endif
624 ## Sphinx provides little control over what content should be included. Some
625 ## mechanisms exist, but they all have drawbacks or actual issues. Since we
626 ## build two different versions of the documentation--once without man pages and
627 ## once, if enabled, with them--some control is necessary. xmpp-wrapper provides
628 ## us with this, but requires running in a temporary directory. It moves the
629 ## correct files into place depending on environment variables.
630         dir=$(dir $@) && \
631         @mkdir_p@ $$dir && \
632         PYTHONPATH=. ENABLE_MANPAGES=$(ENABLE_MANPAGES) COPY_DOC=1 \
633         $(RUN_IN_TEMPDIR) autotools/sphinx-wrapper $(SPHINX) -q -W -b html \
634             -d . \
635             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
636             -D release="$(PACKAGE_VERSION)" \
637             -D graphviz_dot="$(DOT)" \
638             -D enable_manpages="$(ENABLE_MANPAGES)" \
639             doc $(CURDIR)/$$dir && \
640         rm -f $$dir/.buildinfo $$dir/objects.inv
641         touch $@
642
643 doc/html: doc/html/index.html
644
645 doc/man-html: doc/man-html/index.html
646
647 doc/install-quick.rst: INSTALL
648 doc/news.rst: NEWS
649 doc/upgrade.rst: UPGRADE
650
651 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
652         set -e; \
653         { echo '.. This file is automatically updated at build time from $<.'; \
654           echo '.. Do not edit.'; \
655           echo; \
656           cat $<; \
657         } > $@
658
659 doc/manpages-enabled.rst: Makefile | $(built_base_sources)
660         { echo '.. This file is automatically generated, do not edit!'; \
661           echo ''; \
662           echo 'Man pages'; \
663           echo '========='; \
664           echo; \
665           echo '.. toctree::'; \
666           echo '   :maxdepth: 1'; \
667           echo; \
668           for i in $(notdir $(mandocrst)); do \
669             echo "   $$i"; \
670           done | LC_ALL=C sort; \
671         } > $@
672
673 doc/man-%.rst: man/%.gen Makefile $(REPLACE_VARS_SED) | $(built_base_sources)
674 if MANPAGES_IN_DOC
675         { echo '.. This file is automatically updated at build time from $<.'; \
676           echo '.. Do not edit.'; \
677           echo; \
678           echo "$*"; \
679           echo '=========================================='; \
680           tail -n +3 $< | sed -f $(REPLACE_VARS_SED); \
681         } > $@
682 else
683         echo 'Man pages in documentation were disabled at configure time' >&2; \
684         exit 1;
685 endif
686
687 # Things to build but not to install (add it to EXTRA_DIST if it should be
688 # distributed)
689 noinst_DATA = \
690         doc/html \
691         $(BUILT_EXAMPLES) \
692         doc/examples/bash_completion \
693         doc/examples/bash_completion-debug \
694         $(manhtml)
695
696 if MANPAGES_IN_DOC
697 noinst_DATA += doc/man-html
698 endif
699
700 gnt_scripts = \
701         scripts/gnt-backup \
702         scripts/gnt-cluster \
703         scripts/gnt-debug \
704         scripts/gnt-group \
705         scripts/gnt-instance \
706         scripts/gnt-job \
707         scripts/gnt-network \
708         scripts/gnt-node \
709         scripts/gnt-os \
710         scripts/gnt-storage
711
712 PYTHON_BOOTSTRAP_SBIN = \
713         daemons/ganeti-masterd \
714         daemons/ganeti-noded \
715         daemons/ganeti-rapi \
716         daemons/ganeti-watcher \
717         $(gnt_scripts)
718
719 PYTHON_BOOTSTRAP = \
720         $(PYTHON_BOOTSTRAP_SBIN) \
721         tools/burnin \
722         tools/ensure-dirs \
723         tools/node-cleanup \
724         tools/node-daemon-setup \
725         tools/prepare-node-join
726
727 qa_scripts = \
728         qa/__init__.py \
729         qa/ganeti-qa.py \
730         qa/qa_cluster.py \
731         qa/qa_config.py \
732         qa/qa_daemon.py \
733         qa/qa_env.py \
734         qa/qa_error.py \
735         qa/qa_group.py \
736         qa/qa_instance.py \
737         qa/qa_job.py \
738         qa/qa_node.py \
739         qa/qa_os.py \
740         qa/qa_rapi.py \
741         qa/qa_tags.py \
742         qa/qa_utils.py
743
744 bin_SCRIPTS =
745 if WANT_HTOOLS
746 bin_SCRIPTS += $(HS_BIN_PROGS)
747 install-exec-hook:
748         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
749 # FIXME: this is a hardcoded logic, instead of auto-resolving
750         $(LN_S) -f ../../../bin/htools \
751           $(DESTDIR)$(iallocatorsdir)/hail
752         for role in $(HS_BIN_ROLES); do \
753           $(LN_S) -f htools $(DESTDIR)$(bindir)/$$role ; \
754         done
755 endif
756
757 $(HS_ALL_PROGS): %: %.hs $(HS_LIBTESTBUILT_SRCS) Makefile
758         @if [ "$(notdir $@)" = "test" ] && [ "$(HS_NODEV)" ]; then \
759           echo "Error: cannot run unittests without the development" \
760                " libraries (see devnotes.rst)" 1>&2; \
761           exit 1; \
762         fi
763         @rm -f $(notdir $@).tix
764         $(GHC) --make \
765           $(HFLAGS) \
766           $(HS_NOCURL) $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
767           -osuf $(notdir $@).o -hisuf $(notdir $@).hi \
768           $(HEXTRA) $(HEXTRA_INT) $@
769         @touch "$@"
770
771 # for the test/hs/htest binary, we need to enable profiling/coverage
772 test/hs/htest: HEXTRA_INT=-fhpc -itest/hs
773
774 # we compile the hpc-htools binary with the program coverage
775 test/hs/hpc-htools: HEXTRA_INT=-fhpc
776
777 # we compile the hpc-mon-collector binary with the program coverage
778 test/hs/hpc-mon-collector: HEXTRA_INT=-fhpc
779
780 # test dependency
781 test/hs/offline-tests.sh: test/hs/hpc-htools test/hs/hpc-mon-collector
782
783 # rules for building profiling-enabled versions of the haskell
784 # programs: hs-prof does the full two-step build, whereas
785 # hs-prof-quick does only the final rebuild (hs-prof must have been
786 # run before)
787 .PHONY: hs-prof hs-prof-quick
788 hs-prof:
789         @if [ -z "$(TARGET)" ]; then \
790           echo "You need to define TARGET when running this rule" 1>&2; \
791           exit 1; \
792         fi
793         $(MAKE) $(AM_MAKEFLAGS) clean
794         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf o"
795         rm -f $(HS_ALL_PROGS)
796         $(MAKE) $(AM_MAKEFLAGS) hs-prof-quick
797
798 hs-prof-quick:
799         @if [ -z "$(TARGET)" ]; then \
800           echo "You need to define TARGET when running this rule" 1>&2; \
801           exit 1; \
802         fi
803         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf prof_o -prof -auto-all"
804
805 dist_sbin_SCRIPTS = \
806         tools/ganeti-listrunner
807
808 nodist_sbin_SCRIPTS = \
809         $(PYTHON_BOOTSTRAP_SBIN) \
810         daemons/ganeti-cleaner
811
812 if ENABLE_CONFD
813 src/ganeti-confd: src/hconfd
814         cp -f $< $@
815
816 nodist_sbin_SCRIPTS += src/ganeti-confd
817 endif
818
819 python_scripts = \
820         tools/cfgshell \
821         tools/cfgupgrade \
822         tools/cfgupgrade12 \
823         tools/cluster-merge \
824         tools/confd-client \
825         tools/fmtjson \
826         tools/lvmstrap \
827         tools/move-instance \
828         tools/ovfconverter \
829         tools/sanitize-config
830
831 dist_tools_SCRIPTS = \
832         $(python_scripts) \
833         tools/burnin \
834         tools/kvm-console-wrapper \
835         tools/master-ip-setup \
836         tools/xen-console-wrapper
837
838 nodist_tools_python_scripts = \
839         tools/node-cleanup
840
841 nodist_tools_SCRIPTS = \
842         $(nodist_tools_python_scripts) \
843         tools/users-setup \
844         tools/vcluster-setup
845
846 pkglib_python_scripts = \
847         daemons/import-export \
848         tools/check-cert-expired
849
850 nodist_pkglib_python_scripts = \
851         tools/ensure-dirs \
852         tools/node-daemon-setup \
853         tools/prepare-node-join
854
855 myexeclib_SCRIPTS = \
856         daemons/daemon-util \
857         tools/kvm-ifup \
858         $(pkglib_python_scripts) \
859         $(HS_MYEXECLIB_PROGS)
860
861 nodist_myexeclib_SCRIPTS = \
862         $(nodist_pkglib_python_scripts)
863
864 EXTRA_DIST = \
865         NEWS \
866         UPGRADE \
867         epydoc.conf.in \
868         pylintrc \
869         autotools/build-bash-completion \
870         autotools/build-rpc \
871         autotools/check-header \
872         autotools/check-imports \
873         autotools/check-man-dashes \
874         autotools/check-man-references \
875         autotools/check-man-warnings \
876         autotools/check-news \
877         autotools/check-python-code \
878         autotools/check-tar \
879         autotools/check-version \
880         autotools/convert-constants \
881         autotools/docpp \
882         autotools/gen-py-coverage \
883         autotools/sphinx-wrapper \
884         autotools/testrunner \
885         autotools/wrong-hardcoded-paths \
886         $(RUN_IN_TEMPDIR) \
887         daemons/daemon-util.in \
888         daemons/ganeti-cleaner.in \
889         $(pkglib_python_scripts) \
890         devel/upload \
891         devel/webserver \
892         tools/kvm-ifup.in \
893         tools/users-setup.in \
894         tools/vcluster-setup.in \
895         $(docinput) \
896         doc/html \
897         $(BUILT_EXAMPLES:%=%.in) \
898         doc/examples/ganeti.default \
899         doc/examples/ganeti.default-debug \
900         doc/examples/hooks/ethers \
901         doc/examples/gnt-debug/README \
902         doc/examples/gnt-debug/delay0.json \
903         doc/examples/gnt-debug/delay50.json \
904         test/py/lockperf.py \
905         test/py/testutils.py \
906         test/py/mocks.py \
907         $(dist_TESTS) \
908         $(TEST_FILES) \
909         man/footer.rst \
910         $(manrst) \
911         $(maninput) \
912         qa/qa-sample.json \
913         $(qa_scripts) \
914         $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS_IN) \
915         $(HS_PROG_SRCS) \
916         src/lint-hints.hs \
917         test/hs/cli-tests-defs.sh \
918         test/hs/offline-test.sh \
919         .ghci
920
921 man_MANS = \
922         man/ganeti-cleaner.8 \
923         man/ganeti-confd.8 \
924         man/ganeti-listrunner.8 \
925         man/ganeti-masterd.8 \
926         man/ganeti-noded.8 \
927         man/ganeti-os-interface.7 \
928         man/ganeti-extstorage-interface.7 \
929         man/ganeti-rapi.8 \
930         man/ganeti-watcher.8 \
931         man/ganeti.7 \
932         man/gnt-backup.8 \
933         man/gnt-cluster.8 \
934         man/gnt-debug.8 \
935         man/gnt-group.8 \
936         man/gnt-network.8 \
937         man/gnt-instance.8 \
938         man/gnt-job.8 \
939         man/gnt-node.8 \
940         man/gnt-os.8 \
941         man/gnt-storage.8 \
942         man/hail.1 \
943         man/hbal.1 \
944         man/hcheck.1 \
945         man/hinfo.1 \
946         man/hscan.1 \
947         man/hspace.1 \
948         man/hroller.1 \
949         man/htools.1 \
950         man/mon-collector.7
951
952 # Remove extensions from all filenames in man_MANS
953 mannoext = $(patsubst %.1,%,$(patsubst %.7,%,$(patsubst %.8,%,$(man_MANS))))
954
955 manrst = $(patsubst %,%.rst,$(mannoext))
956 manhtml = $(patsubst %.rst,%.html,$(manrst))
957 mangen = $(patsubst %.rst,%.gen,$(manrst))
958 maninput = \
959         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
960         $(patsubst %.html,%.html.in,$(manhtml)) \
961         $(mangen)
962
963 TEST_FILES = \
964         test/data/htools/clean-nonzero-score.data \
965         test/data/htools/common-suffix.data \
966         test/data/htools/empty-cluster.data \
967         test/data/htools/hail-alloc-drbd.json \
968         test/data/htools/hail-alloc-invalid-twodisks.json \
969         test/data/htools/hail-alloc-twodisks.json \
970         test/data/htools/hail-change-group.json \
971         test/data/htools/hail-invalid-reloc.json \
972         test/data/htools/hail-node-evac.json \
973         test/data/htools/hail-reloc-drbd.json \
974         test/data/htools/hbal-excl-tags.data \
975         test/data/htools/hbal-split-insts.data \
976         test/data/htools/hspace-tiered-ipolicy.data \
977         test/data/htools/invalid-node.data \
978         test/data/htools/missing-resources.data \
979         test/data/htools/n1-failure.data \
980         test/data/htools/rapi/groups.json \
981         test/data/htools/rapi/info.json \
982         test/data/htools/rapi/instances.json \
983         test/data/htools/rapi/nodes.json \
984         test/hs/shelltests/htools-balancing.test \
985         test/hs/shelltests/htools-basic.test \
986         test/hs/shelltests/htools-dynutil.test \
987         test/hs/shelltests/htools-excl.test \
988         test/hs/shelltests/htools-hail.test \
989         test/hs/shelltests/htools-hspace.test \
990         test/hs/shelltests/htools-invalid.test \
991         test/hs/shelltests/htools-multi-group.test \
992         test/hs/shelltests/htools-no-backend.test \
993         test/hs/shelltests/htools-rapi.test \
994         test/hs/shelltests/htools-single-group.test \
995         test/hs/shelltests/htools-text-backend.test \
996         test/hs/shelltests/htools-mon-collector.test \
997         test/data/bdev-drbd-8.0.txt \
998         test/data/bdev-drbd-8.3.txt \
999         test/data/bdev-drbd-disk.txt \
1000         test/data/bdev-drbd-net-ip4.txt \
1001         test/data/bdev-drbd-net-ip6.txt \
1002         test/data/bdev-rbd/json_output_empty.txt \
1003         test/data/bdev-rbd/json_output_extra_matches.txt \
1004         test/data/bdev-rbd/json_output_no_matches.txt \
1005         test/data/bdev-rbd/json_output_ok.txt \
1006         test/data/bdev-rbd/plain_output_new_extra_matches.txt \
1007         test/data/bdev-rbd/plain_output_new_no_matches.txt \
1008         test/data/bdev-rbd/plain_output_new_ok.txt \
1009         test/data/bdev-rbd/plain_output_old_empty.txt \
1010         test/data/bdev-rbd/plain_output_old_extra_matches.txt \
1011         test/data/bdev-rbd/plain_output_old_no_matches.txt \
1012         test/data/bdev-rbd/plain_output_old_ok.txt \
1013         test/data/bdev-rbd/output_invalid.txt \
1014         test/data/cert1.pem \
1015         test/data/cert2.pem \
1016         test/data/instance-minor-pairing.txt \
1017         test/data/ip-addr-show-dummy0.txt \
1018         test/data/ip-addr-show-lo-ipv4.txt \
1019         test/data/ip-addr-show-lo-ipv6.txt \
1020         test/data/ip-addr-show-lo-oneline-ipv4.txt \
1021         test/data/ip-addr-show-lo-oneline-ipv6.txt \
1022         test/data/ip-addr-show-lo-oneline.txt \
1023         test/data/ip-addr-show-lo.txt \
1024         test/data/kvm_0.12.5_help.txt \
1025         test/data/kvm_0.15.90_help.txt \
1026         test/data/kvm_0.9.1_help.txt \
1027         test/data/kvm_0.9.1_help_boot_test.txt \
1028         test/data/kvm_1.0_help.txt \
1029         test/data/kvm_1.1.2_help.txt \
1030         test/data/ovfdata/compr_disk.vmdk.gz \
1031         test/data/ovfdata/config.ini \
1032         test/data/ovfdata/corrupted_resources.ovf \
1033         test/data/ovfdata/empty.ini \
1034         test/data/ovfdata/empty.ovf \
1035         test/data/ovfdata/ganeti.mf \
1036         test/data/ovfdata/ganeti.ovf \
1037         test/data/ovfdata/gzip_disk.ovf \
1038         test/data/ovfdata/new_disk.vmdk \
1039         test/data/ovfdata/no_disk.ini \
1040         test/data/ovfdata/no_disk_in_ref.ovf \
1041         test/data/ovfdata/no_os.ini \
1042         test/data/ovfdata/no_ovf.ova \
1043         test/data/ovfdata/other/rawdisk.raw \
1044         test/data/ovfdata/ova.ova \
1045         test/data/ovfdata/rawdisk.raw \
1046         test/data/ovfdata/second_disk.vmdk \
1047         test/data/ovfdata/unsafe_path.ini \
1048         test/data/ovfdata/virtualbox.ovf \
1049         test/data/ovfdata/wrong_config.ini \
1050         test/data/ovfdata/wrong_extension.ovd \
1051         test/data/ovfdata/wrong_manifest.mf \
1052         test/data/ovfdata/wrong_manifest.ovf \
1053         test/data/ovfdata/wrong_ova.ova \
1054         test/data/ovfdata/wrong_xml.ovf \
1055         test/data/proc_drbd8.txt \
1056         test/data/proc_drbd80-emptyline.txt \
1057         test/data/proc_drbd83.txt \
1058         test/data/proc_drbd83_sync.txt \
1059         test/data/proc_drbd83_sync_want.txt \
1060         test/data/proc_drbd83_sync_krnl2.6.39.txt \
1061         test/data/sys_drbd_usermode_helper.txt \
1062         test/data/vgreduce-removemissing-2.02.02.txt \
1063         test/data/vgreduce-removemissing-2.02.66-fail.txt \
1064         test/data/vgreduce-removemissing-2.02.66-ok.txt \
1065         test/data/vgs-missing-pvs-2.02.02.txt \
1066         test/data/vgs-missing-pvs-2.02.66.txt \
1067         test/py/ganeti-cli.test \
1068         test/py/gnt-cli.test \
1069         test/py/import-export_unittest-helper
1070
1071 python_tests = \
1072         doc/examples/rapi_testutils.py \
1073         test/py/cfgupgrade_unittest.py \
1074         test/py/docs_unittest.py \
1075         test/py/ganeti.asyncnotifier_unittest.py \
1076         test/py/ganeti.backend_unittest-runasroot.py \
1077         test/py/ganeti.backend_unittest.py \
1078         test/py/ganeti.bdev_unittest.py \
1079         test/py/ganeti.cli_unittest.py \
1080         test/py/ganeti.client.gnt_cluster_unittest.py \
1081         test/py/ganeti.client.gnt_instance_unittest.py \
1082         test/py/ganeti.client.gnt_job_unittest.py \
1083         test/py/ganeti.cmdlib_unittest.py \
1084         test/py/ganeti.compat_unittest.py \
1085         test/py/ganeti.confd.client_unittest.py \
1086         test/py/ganeti.config_unittest.py \
1087         test/py/ganeti.constants_unittest.py \
1088         test/py/ganeti.daemon_unittest.py \
1089         test/py/ganeti.errors_unittest.py \
1090         test/py/ganeti.hooks_unittest.py \
1091         test/py/ganeti.ht_unittest.py \
1092         test/py/ganeti.http_unittest.py \
1093         test/py/ganeti.hypervisor.hv_chroot_unittest.py \
1094         test/py/ganeti.hypervisor.hv_fake_unittest.py \
1095         test/py/ganeti.hypervisor.hv_kvm_unittest.py \
1096         test/py/ganeti.hypervisor.hv_lxc_unittest.py \
1097         test/py/ganeti.hypervisor.hv_xen_unittest.py \
1098         test/py/ganeti.hypervisor_unittest.py \
1099         test/py/ganeti.impexpd_unittest.py \
1100         test/py/ganeti.jqueue_unittest.py \
1101         test/py/ganeti.jstore_unittest.py \
1102         test/py/ganeti.locking_unittest.py \
1103         test/py/ganeti.luxi_unittest.py \
1104         test/py/ganeti.masterd.iallocator_unittest.py \
1105         test/py/ganeti.masterd.instance_unittest.py \
1106         test/py/ganeti.mcpu_unittest.py \
1107         test/py/ganeti.netutils_unittest.py \
1108         test/py/ganeti.objects_unittest.py \
1109         test/py/ganeti.opcodes_unittest.py \
1110         test/py/ganeti.outils_unittest.py \
1111         test/py/ganeti.ovf_unittest.py \
1112         test/py/ganeti.qlang_unittest.py \
1113         test/py/ganeti.query_unittest.py \
1114         test/py/ganeti.rapi.baserlib_unittest.py \
1115         test/py/ganeti.rapi.client_unittest.py \
1116         test/py/ganeti.rapi.resources_unittest.py \
1117         test/py/ganeti.rapi.rlib2_unittest.py \
1118         test/py/ganeti.rapi.testutils_unittest.py \
1119         test/py/ganeti.rpc_unittest.py \
1120         test/py/ganeti.runtime_unittest.py \
1121         test/py/ganeti.serializer_unittest.py \
1122         test/py/ganeti.server.rapi_unittest.py \
1123         test/py/ganeti.ssconf_unittest.py \
1124         test/py/ganeti.ssh_unittest.py \
1125         test/py/ganeti.storage_unittest.py \
1126         test/py/ganeti.tools.burnin_unittest.py \
1127         test/py/ganeti.tools.ensure_dirs_unittest.py \
1128         test/py/ganeti.tools.node_daemon_setup_unittest.py \
1129         test/py/ganeti.tools.prepare_node_join_unittest.py \
1130         test/py/ganeti.uidpool_unittest.py \
1131         test/py/ganeti.utils.algo_unittest.py \
1132         test/py/ganeti.utils.filelock_unittest.py \
1133         test/py/ganeti.utils.hash_unittest.py \
1134         test/py/ganeti.utils.io_unittest-runasroot.py \
1135         test/py/ganeti.utils.io_unittest.py \
1136         test/py/ganeti.utils.log_unittest.py \
1137         test/py/ganeti.utils.lvm_unittest.py \
1138         test/py/ganeti.utils.mlock_unittest.py \
1139         test/py/ganeti.utils.nodesetup_unittest.py \
1140         test/py/ganeti.utils.process_unittest.py \
1141         test/py/ganeti.utils.retry_unittest.py \
1142         test/py/ganeti.utils.text_unittest.py \
1143         test/py/ganeti.utils.wrapper_unittest.py \
1144         test/py/ganeti.utils.x509_unittest.py \
1145         test/py/ganeti.utils_unittest.py \
1146         test/py/ganeti.vcluster_unittest.py \
1147         test/py/ganeti.workerpool_unittest.py \
1148         test/py/pycurl_reset_unittest.py \
1149         test/py/qa.qa_config_unittest.py \
1150         test/py/tempfile_fork_unittest.py
1151
1152 haskell_tests = test/hs/htest
1153
1154 dist_TESTS = \
1155         test/py/check-cert-expired_unittest.bash \
1156         test/py/daemon-util_unittest.bash \
1157         test/py/ganeti-cleaner_unittest.bash \
1158         test/py/import-export_unittest.bash \
1159         test/py/cli-test.bash \
1160         test/py/bash_completion.bash \
1161         $(python_tests)
1162
1163 nodist_TESTS =
1164 check_SCRIPTS =
1165
1166 if WANT_HSTESTS
1167 nodist_TESTS += $(haskell_tests)
1168 dist_TESTS += test/hs/offline-test.sh
1169 check_SCRIPTS += \
1170         test/hs/hpc-htools \
1171         test/hs/hpc-mon-collector \
1172         $(HS_BUILT_TEST_HELPERS)
1173 endif
1174
1175 TESTS = $(dist_TESTS) $(nodist_TESTS)
1176
1177 # Environment for all tests
1178 PLAIN_TESTS_ENVIRONMENT = \
1179         PYTHONPATH=. \
1180         TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
1181         PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
1182         $(RUN_IN_TEMPDIR)
1183
1184 # Environment for tests run by automake
1185 TESTS_ENVIRONMENT = \
1186         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
1187
1188 all_python_code = \
1189         $(dist_sbin_SCRIPTS) \
1190         $(python_scripts) \
1191         $(pkglib_python_scripts) \
1192         $(nodist_pkglib_python_scripts) \
1193         $(nodist_tools_python_scripts) \
1194         $(python_tests) \
1195         $(pkgpython_PYTHON) \
1196         $(client_PYTHON) \
1197         $(hypervisor_PYTHON) \
1198         $(rapi_PYTHON) \
1199         $(server_PYTHON) \
1200         $(pytools_PYTHON) \
1201         $(http_PYTHON) \
1202         $(confd_PYTHON) \
1203         $(masterd_PYTHON) \
1204         $(impexpd_PYTHON) \
1205         $(utils_PYTHON) \
1206         $(watcher_PYTHON) \
1207         $(noinst_PYTHON) \
1208         $(qa_scripts)
1209
1210 srclink_files = \
1211         man/footer.rst \
1212         test/py/check-cert-expired_unittest.bash \
1213         test/py/daemon-util_unittest.bash \
1214         test/py/ganeti-cleaner_unittest.bash \
1215         test/py/import-export_unittest.bash \
1216         test/py/cli-test.bash \
1217         test/py/bash_completion.bash \
1218         test/hs/offline-test.sh \
1219         test/hs/cli-tests-defs.sh \
1220         $(all_python_code) \
1221         $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS) \
1222         $(docinput)
1223
1224 check_python_code = \
1225         $(BUILD_BASH_COMPLETION) \
1226         $(CHECK_IMPORTS) \
1227         $(CHECK_HEADER) \
1228         $(DOCPP) \
1229         $(all_python_code)
1230
1231 lint_python_code = \
1232         ganeti \
1233         ganeti/http/server.py \
1234         $(dist_sbin_SCRIPTS) \
1235         $(python_scripts) \
1236         $(pkglib_python_scripts) \
1237         $(BUILD_BASH_COMPLETION) \
1238         $(CHECK_IMPORTS) \
1239         $(CHECK_HEADER) \
1240         $(DOCPP) \
1241         $(PYTHON_BOOTSTRAP)
1242
1243 standalone_python_modules = \
1244         lib/rapi/client.py \
1245         tools/ganeti-listrunner
1246
1247 pep8_python_code = \
1248         ganeti \
1249         ganeti/http/server.py \
1250         $(dist_sbin_SCRIPTS) \
1251         $(python_scripts) \
1252         $(pkglib_python_scripts) \
1253         $(BUILD_BASH_COMPLETION) \
1254         $(CHECK_HEADER) \
1255         $(DOCPP) \
1256         $(PYTHON_BOOTSTRAP) \
1257         qa
1258
1259 test/py/daemon-util_unittest.bash: daemons/daemon-util
1260
1261 test/py/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
1262
1263 test/py/bash_completion.bash: doc/examples/bash_completion-debug
1264
1265 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
1266         sed -f $(REPLACE_VARS_SED) < $< > $@
1267         chmod +x $@
1268
1269 tools/users-setup: tools/users-setup.in $(REPLACE_VARS_SED)
1270         sed -f $(REPLACE_VARS_SED) < $< > $@
1271         chmod +x $@
1272
1273 tools/vcluster-setup: tools/vcluster-setup.in $(REPLACE_VARS_SED)
1274         sed -f $(REPLACE_VARS_SED) < $< > $@
1275         chmod +x $@
1276
1277 daemons/%:: daemons/%.in $(REPLACE_VARS_SED)
1278         sed -f $(REPLACE_VARS_SED) < $< > $@
1279         chmod +x $@
1280
1281 doc/examples/%:: doc/examples/%.in $(REPLACE_VARS_SED)
1282         sed -f $(REPLACE_VARS_SED) < $< > $@
1283
1284 doc/examples/bash_completion: BC_ARGS = --compact
1285 doc/examples/bash_completion-debug: BC_ARGS =
1286
1287 doc/examples/bash_completion doc/examples/bash_completion-debug: \
1288         $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
1289         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin \
1290         daemons/ganeti-cleaner \
1291         $(GENERATED_FILES) $(HS_GENERATED_FILES)
1292         PYTHONPATH=. $(RUN_IN_TEMPDIR) \
1293           $(CURDIR)/$(BUILD_BASH_COMPLETION) $(BC_ARGS) > $@
1294
1295 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
1296         lib/build/shell_example_lexer.py \
1297         | $(RUN_IN_TEMPDIR) $(BUILT_PYTHON_SOURCES)
1298         @echo "Checking $< for hardcoded paths..."
1299         @if grep -nEf autotools/wrong-hardcoded-paths $<; then \
1300           echo "Man page $< has hardcoded paths (see above)!" 1>&2 ; \
1301           exit 1; \
1302         fi
1303         set -e ; \
1304         trap 'echo auto-removing $@; rm $@' EXIT; \
1305         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@ ;\
1306         $(CHECK_MAN_REFERENCES) $@; \
1307         trap - EXIT
1308
1309 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.rst
1310         @test -n "$(PANDOC)" || \
1311           { echo 'pandoc' not found during configure; exit 1; }
1312         set -o pipefail -e; \
1313         trap 'echo auto-removing $@; rm $@' EXIT; \
1314         $(PANDOC) -s -f rst -t man $< man/footer.rst | \
1315           sed -e 's/\\@/@/g' > $@; \
1316         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
1317         $(CHECK_MAN_DASHES) $@; \
1318         trap - EXIT
1319
1320 man/%.html.in: man/%.gen man/footer.rst
1321         @test -n "$(PANDOC)" || \
1322           { echo 'pandoc' not found during configure; exit 1; }
1323         set -o pipefail ; \
1324         $(PANDOC) --toc -s -f rst -t html $< man/footer.rst | \
1325           sed -e 's/\\@/@/g' > $@
1326
1327 man/%: man/%.in  $(REPLACE_VARS_SED)
1328         sed -f $(REPLACE_VARS_SED) < $< > $@
1329
1330 epydoc.conf: epydoc.conf.in $(REPLACE_VARS_SED)
1331         sed -f $(REPLACE_VARS_SED) < $< > $@
1332
1333 vcs-version:
1334         if test -d .git; then \
1335           git describe > $@; \
1336         elif test ! -f $@ ; then \
1337           echo "Cannot auto-generate $@ file"; exit 1; \
1338         fi
1339
1340 .PHONY: clean-vcs-version
1341 clean-vcs-version:
1342         rm -f vcs-version
1343
1344 .PHONY: regen-vcs-version
1345 regen-vcs-version:
1346         @set -e; \
1347         cd $(srcdir); \
1348         if test -d .git; then \
1349           T=`mktemp` ; trap 'rm -f $$T' EXIT; \
1350           git describe > $$T; \
1351           if ! cmp --quiet $$T vcs-version; then \
1352             mv $$T vcs-version; \
1353           fi; \
1354         fi
1355
1356 src/Ganeti/Version.hs: src/Ganeti/Version.hs.in \
1357         vcs-version $(built_base_sources)
1358         set -e; \
1359         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1360         sed -e "s/%ver%/$$VCSVER/" < $< > $@
1361
1362 src/Ganeti/Constants.hs: src/Ganeti/Constants.hs.in \
1363         lib/constants.py lib/_autoconf.py lib/luxi.py lib/errors.py \
1364         lib/jstore.py $(RUN_IN_TEMPDIR) \
1365         $(CONVERT_CONSTANTS) $(built_base_sources) \
1366         | lib/_vcsversion.py
1367         set -e; \
1368         { cat $< ; \
1369           PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CONVERT_CONSTANTS); \
1370         } > $@
1371
1372 test/hs/Test/Ganeti/TestImports.hs: test/hs/Test/Ganeti/TestImports.hs.in \
1373         $(built_base_sources)
1374         set -e; \
1375         { cat $< ; \
1376           echo ; \
1377           for name in $(filter-out Ganeti.THH,$(subst /,.,$(patsubst %.hs,%,$(patsubst src/%,%,$(HS_LIB_SRCS))))) ; do \
1378             echo "import $$name ()" ; \
1379           done ; \
1380         } > $@
1381
1382 lib/_autoconf.py: Makefile | stamp-directories
1383         set -e; \
1384         { echo '# This file is automatically generated, do not edit!'; \
1385           echo '#'; \
1386           echo ''; \
1387           echo '"""Build-time configuration for Ganeti.'; \
1388           echo '';\
1389           echo 'This file is autogenerated by the build process.'; \
1390           echo 'For any changes you need to re-run ./configure (and'; \
1391           echo 'not edit by hand).'; \
1392           echo ''; \
1393           echo '"""'; \
1394           echo ''; \
1395           echo '# pylint: disable=C0301,C0324'; \
1396           echo '# because this is autogenerated, we do not want'; \
1397           echo '# style warnings' ; \
1398           echo ''; \
1399           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
1400           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
1401           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
1402           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
1403           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
1404           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
1405           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
1406           echo "SYSCONFDIR = '$(sysconfdir)'"; \
1407           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
1408           echo "SSH_LOGIN_USER = '$(SSH_LOGIN_USER)'"; \
1409           echo "SSH_CONSOLE_USER = '$(SSH_CONSOLE_USER)'"; \
1410           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
1411           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
1412           echo "ES_SEARCH_PATH = [$(ES_SEARCH_PATH)]"; \
1413           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1414           echo "XEN_CONFIG_DIR = '$(XEN_CONFIG_DIR)'"; \
1415           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1416           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1417           echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
1418           echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
1419           echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
1420           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
1421           echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
1422           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1423           echo "KVM_PATH = '$(KVM_PATH)'"; \
1424           echo "IP_PATH = '$(IP_PATH)'"; \
1425           echo "SOCAT_PATH = '$(SOCAT)'"; \
1426           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1427           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1428           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1429           echo "TOOLSDIR = '$(toolsdir)'"; \
1430           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1431           echo "HTOOLS_PROGS = [$(foreach i,$(HS_HTOOLS_PROGS),'$(i)',)]"; \
1432           echo "PKGLIBDIR = '$(pkglibdir)'"; \
1433           echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1434           echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1435           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1436           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1437           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1438           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1439           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1440           echo "RAPI_USER = '$(RAPI_USER)'"; \
1441           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1442           echo "CONFD_USER = '$(CONFD_USER)'"; \
1443           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1444           echo "NODED_USER = '$(NODED_USER)'"; \
1445           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1446           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1447           echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1448           echo "HTOOLS = True"; \
1449           echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1450           echo "XEN_CMD = '$(XEN_CMD)'"; \
1451           echo "ENABLE_SPLIT_QUERY = $(ENABLE_SPLIT_QUERY)"; \
1452           echo "ENABLE_RESTRICTED_COMMANDS = $(ENABLE_RESTRICTED_COMMANDS)"; \
1453           echo "ENABLE_MONITORING = $(ENABLE_MONITORING)"; \
1454 ## Write dictionary with man page name as the key and the section number as the
1455 ## value
1456           echo "MAN_PAGES = {"; \
1457           for i in $(notdir $(man_MANS)); do \
1458             echo "$$i" | sed -re 's/^(.*)\.([0-9]+)$$/  "\1": \2,/g'; \
1459           done; \
1460           echo "}"; \
1461         } > $@
1462
1463 lib/_vcsversion.py: Makefile vcs-version | stamp-directories
1464         set -e; \
1465         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1466         { echo '# This file is automatically generated, do not edit!'; \
1467           echo '#'; \
1468           echo ''; \
1469           echo '"""Build-time VCS version number for Ganeti.'; \
1470           echo '';\
1471           echo 'This file is autogenerated by the build process.'; \
1472           echo 'For any changes you need to re-run ./configure (and'; \
1473           echo 'not edit by hand).'; \
1474           echo ''; \
1475           echo '"""'; \
1476           echo ''; \
1477           echo '# pylint: disable=C0301,C0324'; \
1478           echo '# because this is autogenerated, we do not want'; \
1479           echo '# style warnings' ; \
1480           echo ''; \
1481           echo "VCS_VERSION = '$$VCSVER'"; \
1482         } > $@
1483
1484 lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1485         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1486
1487 $(SHELL_ENV_INIT): Makefile stamp-directories
1488         set -e; \
1489         { echo '# Allow overriding for tests'; \
1490           echo 'readonly LOCALSTATEDIR=$${LOCALSTATEDIR:-$${GANETI_ROOTDIR:-}$(localstatedir)}'; \
1491           echo 'readonly SYSCONFDIR=$${SYSCONFDIR:-$${GANETI_ROOTDIR:-}$(sysconfdir)}'; \
1492           echo; \
1493           echo 'readonly PKGLIBDIR=$(pkglibdir)'; \
1494           echo 'readonly LOG_DIR="$$LOCALSTATEDIR/log/ganeti"'; \
1495           echo 'readonly RUN_DIR="$$LOCALSTATEDIR/run/ganeti"'; \
1496           echo 'readonly DATA_DIR="$$LOCALSTATEDIR/lib/ganeti"'; \
1497           echo 'readonly CONF_DIR="$$SYSCONFDIR/ganeti"'; \
1498         } > $@
1499
1500 ## Writes sed script to replace placeholders with build-time values. The
1501 ## additional quotes after the first @ sign are necessary to stop configure
1502 ## from replacing those values as well.
1503 $(REPLACE_VARS_SED): $(SHELL_ENV_INIT) Makefile stamp-directories
1504         set -e; \
1505         { echo 's#@''PREFIX@#$(prefix)#g'; \
1506           echo 's#@''SYSCONFDIR@#$(sysconfdir)#g'; \
1507           echo 's#@''LOCALSTATEDIR@#$(localstatedir)#g'; \
1508           echo 's#@''BINDIR@#$(bindir)#g'; \
1509           echo 's#@''SBINDIR@#$(sbindir)#g'; \
1510           echo 's#@''LIBDIR@#$(libdir)#g'; \
1511           echo 's#@''GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1512           echo 's#@''CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1513           echo 's#@''CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1514           echo 's#@''CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1515           echo 's#@''CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1516           echo 's#@''CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1517           echo 's#@''RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
1518           echo 's#@''RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1519           echo 's#@''PKGLIBDIR@#$(pkglibdir)#g'; \
1520           echo 's#@''GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1521           echo 's#@''GNTRAPIUSER@#$(RAPI_USER)#g'; \
1522           echo 's#@''GNTCONFDUSER@#$(CONFD_USER)#g'; \
1523           echo 's#@''GNTNODEDUSER@#$(NODED_USER)#g'; \
1524           echo 's#@''GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1525           echo 's#@''GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1526           echo 's#@''GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1527           echo 's#@''GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1528           echo 's#@''GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1529           echo 's#@''CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1530           echo 's#@''MODULES@#$(strip $(lint_python_code))#g'; \
1531           echo 's#@''XEN_CONFIG_DIR@#$(XEN_CONFIG_DIR)#g'; \
1532           echo; \
1533           echo '/^@SHELL_ENV_INIT@$$/ {'; \
1534           echo '  r $(SHELL_ENV_INIT)'; \
1535           echo '  d'; \
1536           echo '}'; \
1537         } > $@
1538
1539 # Using deferred evaluation
1540 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1541 daemons/ganeti-watcher: MODULE = ganeti.watcher
1542 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1543 tools/burnin: MODULE = ganeti.tools.burnin
1544 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1545 tools/node-daemon-setup: MODULE = ganeti.tools.node_daemon_setup
1546 tools/prepare-node-join: MODULE = ganeti.tools.prepare_node_join
1547 tools/node-cleanup: MODULE = ganeti.tools.node_cleanup
1548 $(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst test/hs/%,%,$@)
1549
1550 $(PYTHON_BOOTSTRAP): Makefile | stamp-directories
1551         test -n "$(MODULE)" || { echo Missing module; exit 1; }
1552         set -e; \
1553         { echo '#!/usr/bin/python'; \
1554           echo '# This file is automatically generated, do not edit!'; \
1555           echo "# Edit $(MODULE) instead."; \
1556           echo; \
1557           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1558           echo; \
1559           echo '# pylint: disable=C0103'; \
1560           echo '# C0103: Invalid name'; \
1561           echo; \
1562           echo 'import sys'; \
1563           echo 'import $(MODULE) as main'; \
1564           echo; \
1565           echo '# Temporarily alias commands until bash completion'; \
1566           echo '# generator is changed'; \
1567           echo 'if hasattr(main, "commands"):'; \
1568           echo '  commands = main.commands # pylint: disable=E1101'; \
1569           echo 'if hasattr(main, "aliases"):'; \
1570           echo '  aliases = main.aliases # pylint: disable=E1101'; \
1571           echo; \
1572           echo 'if __name__ == "__main__":'; \
1573           echo '  sys.exit(main.Main())'; \
1574         } > $@
1575         chmod u+x $@
1576
1577 $(HS_BUILT_TEST_HELPERS): Makefile
1578         @test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
1579         set -e; \
1580         { echo '#!/bin/sh'; \
1581           echo '# This file is automatically generated, do not edit!'; \
1582           echo "# Edit Makefile.am instead."; \
1583           echo; \
1584           echo "HTOOLS=$(TESTROLE) exec ./test/hs/hpc-htools \"\$$@\""; \
1585         } > $@
1586         chmod u+x $@
1587
1588 stamp-directories: Makefile
1589         $(MAKE) $(AM_MAKEFLAGS) ganeti
1590         @mkdir_p@ $(DIRS) $(BUILDTIME_DIR_AUTOCREATE)
1591         touch $@
1592
1593 # We need to create symlinks because "make distcheck" will not install Python
1594 # files when building.
1595 stamp-srclinks: Makefile | stamp-directories
1596         set -e; \
1597         for i in $(srclink_files); do \
1598           if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1599             $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1600           fi; \
1601         done
1602         touch $@
1603
1604 .PHONY: ganeti
1605 ganeti:
1606         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1607
1608 .PHONY: check-dirs
1609 check-dirs: $(GENERATED_FILES)
1610         @set -e; \
1611         find . -type d \( -name . -o -name .git -prune -o -print \) | { \
1612           error=; \
1613           while read dir; do \
1614             case "$$dir" in \
1615               $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1616               *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1617             esac; \
1618           done; \
1619           for dir in $(DIRS); do \
1620             if ! test -d "$$dir"; then \
1621               echo "Directory $$dir listed in DIRS does not exist" >&2; \
1622               error=1; \
1623             fi \
1624           done; \
1625           test -z "$$error"; \
1626         }
1627
1628 .PHONY: check-local
1629 check-local: check-dirs $(GENERATED_FILES)
1630         $(CHECK_PYTHON_CODE) $(check_python_code)
1631         PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1632         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1633         RELEASE=$(PACKAGE_VERSION) $(CHECK_NEWS) < $(top_srcdir)/NEWS
1634         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1635         @expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1636         error= ; \
1637         if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1638           echo "Incorrect version in README, expected $$expver" >&2; \
1639           error=1; \
1640         fi; \
1641         for file in doc/iallocator.rst doc/hooks.rst doc/virtual-cluster.rst \
1642             doc/security.rst; do \
1643           if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1644             "Documents Ganeti version $$expver"; then \
1645             echo "Incorrect version in $$file, expected $$expver" >&2; \
1646             error=1; \
1647           fi; \
1648         done; \
1649         if ! test -f $(top_srcdir)/doc/design-$$expver.rst; then \
1650           echo "File $(top_srcdir)/doc/design-$$expver.rst not found" >&2; \
1651           error=1; \
1652         fi; \
1653         if test "`sed -ne '5 p' $(top_srcdir)/doc/design-draft.rst`" != \
1654           ".. Last updated for Ganeti $$expver"; then \
1655           echo "doc/design-draft.rst was not updated for version $$expver" >&2; \
1656           error=1; \
1657         fi; \
1658         for file in configure.ac $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS); do \
1659           if test $$(wc --max-line-length < $(top_srcdir)/$$file) -gt 80; then \
1660             echo "Longest line in $$file is longer than 80 characters" >&2; \
1661             error=1; \
1662           fi; \
1663         done; \
1664         test -z "$$error"
1665
1666 .PHONY: hs-tests
1667 hs-tests: test/hs/htest | $(BUILT_PYTHON_SOURCES)
1668         @rm -f htest.tix
1669         ./test/hs/htest
1670
1671 .PHONY: hs-shell
1672 hs-shell: test/hs/hpc-htools test/hs/hpc-mon-collector $(HS_BUILT_TEST_HELPERS)
1673         @rm -f hpc-htools.tix hpc-mon-collector.tix
1674         HBINARY="./test/hs/hpc-htools" ./test/hs/offline-test.sh
1675
1676 .PHONY: hs-check
1677 hs-check: hs-tests hs-shell
1678
1679 # E111: indentation is not a multiple of four
1680 # E121: continuation line indentation is not a multiple of four
1681 #       (since our indent level is not 4)
1682 # E125: continuation line does not distinguish itself from next logical line
1683 #       (since our indent level is not 4)
1684 # E127: continuation line over-indented for visual indent
1685 #       (since our indent level is not 4)
1686 # note: do NOT add E128 here; it's a valid style error in most cases!
1687 # I've seen real errors, but also some cases were we indent wrongly
1688 # due to line length; try to rework the cases where it is triggered,
1689 # instead of silencing it
1690 # E261: at least two spaces before inline comment
1691 # E501: line too long (80 characters)
1692 PEP8_IGNORE = E111,E121,E125,E127,E261,E501
1693
1694 # For excluding pep8 expects filenames only, not whole paths
1695 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1696
1697 LINT_TARGETS = pylint pylint-qa
1698 if HAS_PEP8
1699 LINT_TARGETS += pep8
1700 endif
1701 if HAS_HLINT
1702 LINT_TARGETS += hlint
1703 endif
1704
1705 .PHONY: lint
1706 lint: $(LINT_TARGETS)
1707
1708 .PHONY: pylint
1709 pylint: $(GENERATED_FILES)
1710         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1711         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1712
1713 .PHONY: pylint-qa
1714 pylint-qa: $(GENERATED_FILES)
1715         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1716         cd $(top_srcdir)/qa && \
1717           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1718           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1719
1720 .PHONY: pep8
1721 pep8: $(GENERATED_FILES)
1722         @test -n "$(PEP8)" || { echo 'pep8' not found during configure; exit 1; }
1723         $(PEP8) --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1724           --repeat $(pep8_python_code)
1725
1726 # FIXME: remove ignore "Use void" when GHC 6.x is deprecated
1727 HLINT_EXCLUDES = src/Ganeti/THH.hs test/hs/hpc-htools.hs
1728 .PHONY: hlint
1729 hlint: $(HS_BUILT_SRCS) src/lint-hints.hs
1730         @test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
1731         @rm -f doc/hs-lint.html
1732         if tty -s; then C="-c"; else C=""; fi; \
1733         $(HLINT) --utf8 --report=doc/hs-lint.html --cross $$C \
1734           --ignore "Use first" \
1735           --ignore "Use &&&" \
1736           --ignore "Use void" \
1737           --ignore "Reduce duplication" \
1738           --hint src/lint-hints \
1739           $(filter-out $(HLINT_EXCLUDES),$(HS_LIBTEST_SRCS) $(HS_PROG_SRCS))
1740         @if [ ! -f doc/hs-lint.html ]; then \
1741           echo "All good" > doc/hs-lint.html; \
1742         fi
1743
1744 # a dist hook rule for updating the vcs-version file; this is
1745 # hardcoded due to where it needs to build the file...
1746 dist-hook:
1747         $(MAKE) $(AM_MAKEFLAGS) regen-vcs-version
1748         rm -f $(top_distdir)/vcs-version
1749         cp -p $(srcdir)/vcs-version $(top_distdir)
1750
1751 # a distcheck hook rule for catching revision control directories
1752 distcheck-hook:
1753         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1754           echo "Found revision control files in final archive." 1>&2; \
1755           exit 1; \
1756         fi
1757         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1758           echo "Found Python byte code in final archive." 1>&2; \
1759           exit 1; \
1760         fi
1761         if find $(top_distdir) -name '*~' | grep .; then \
1762           echo "Found backup files in final archive." 1>&2; \
1763           exit 1; \
1764         fi
1765 # Empty files or directories should not be distributed. They can cause
1766 # unnecessary warnings for packagers. Directories used by automake during
1767 # distcheck must be excluded.
1768         if find $(top_distdir) -empty -and -not \( \
1769             -path $(top_distdir)/_build -or \
1770             -path $(top_distdir)/_inst \) | grep .; then \
1771           echo "Found empty files or directories in final archive." 1>&2; \
1772           exit 1; \
1773         fi
1774         if test -e $(top_distdir)/doc/man-html; then \
1775           echo "Found documentation including man pages in final archive" >&2; \
1776           exit 1; \
1777         fi
1778
1779 # Backwards compatible distcheck-release target
1780 distcheck-release: distcheck
1781
1782 distrebuildcheck: dist
1783         set -e; \
1784         builddir=$$(mktemp -d $(abs_srcdir)/distrebuildcheck.XXXXXXX); \
1785         trap "echo Removing $$builddir; cd $(abs_srcdir); rm -rf $$builddir" EXIT; \
1786         cd $$builddir; \
1787         tar xzf $(abs_srcdir)/$(distdir).tar.gz; \
1788         cd $(distdir); \
1789         ./configure; \
1790         $(MAKE) maintainer-clean; \
1791         cp $(abs_srcdir)/vcs-version .; \
1792         ./configure; \
1793         $(MAKE) $(AM_MAKEFLAGS)
1794
1795 dist-release: dist
1796         set -e; \
1797         for i in $(DIST_ARCHIVES); do \
1798           echo -n "Checking $$i ... "; \
1799           autotools/check-tar < $$i; \
1800           echo OK; \
1801         done
1802
1803 install-exec-local:
1804         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1805           "$(DESTDIR)${localstatedir}/log/ganeti" \
1806           "$(DESTDIR)${localstatedir}/run/ganeti"
1807
1808 .PHONY: apidoc
1809 if WANT_HSAPIDOC
1810 apidoc: py-apidoc hs-apidoc
1811 else
1812 apidoc: py-apidoc
1813 endif
1814
1815 .PHONY: py-apidoc
1816 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(GENERATED_FILES)
1817         env - PATH="$$PATH" PYTHONPATH="$$PYTHONPATH" \
1818         $(RUN_IN_TEMPDIR) epydoc -v \
1819           --conf $(CURDIR)/epydoc.conf \
1820           --output $(CURDIR)/$(APIDOC_PY_DIR)
1821
1822 .PHONY: hs-apidoc
1823 hs-apidoc: $(APIDOC_HS_DIR)/index.html
1824
1825 $(APIDOC_HS_DIR)/index.html: $(HS_LIBTESTBUILT_SRCS) Makefile
1826         @test -n "$(HSCOLOUR)" || \
1827             { echo 'HsColour' not found during configure; exit 1; }
1828         @test -n "$(HADDOCK)" || \
1829             { echo 'haddock' not found during configure; exit 1; }
1830         rm -rf $(APIDOC_HS_DIR)/*
1831         for i in $(ALL_APIDOC_HS_DIRS); do \
1832           @mkdir_p@ $$i; \
1833           $(HSCOLOUR) -print-css > $$i/hscolour.css; \
1834         done
1835         set -e ; \
1836         export LC_ALL=en_US.UTF-8; \
1837         OPTGHC="--optghc=-isrc --optghc=-itest/hs"; \
1838         if [ "$(HS_NOCURL)" ]; \
1839         then OPTGHC="$$OPTGHC --optghc=$(HS_NOCURL)"; \
1840         fi; \
1841         if [ "$(HS_PARALLEL3)" ]; \
1842         then OPTGHC="$$OPTGHC --optghc=$(HS_PARALLEL3)"; \
1843         fi; \
1844         if [ "$(HS_REGEX_PCRE)" ]; \
1845         then OPTGHC="$$OPTGHC --optghc=$(HS_REGEX_PCRE)"; \
1846         fi; \
1847         for file in $(HS_LIBTESTBUILT_SRCS); do \
1848           f_nosrc=$${file##src/}; \
1849           f_notst=$${f_nosrc##test/hs/}; \
1850           f_html=$${f_notst%%.hs}.html; \
1851           $(HSCOLOUR) -css -anchor $$file > $(APIDOC_HS_DIR)/$$f_html ; \
1852         done ; \
1853         $(HADDOCK) --odir $(APIDOC_HS_DIR) --html --ignore-all-exports -w \
1854           -t ganeti -p src/haddock-prologue \
1855           --source-module="%{MODULE/.//}.html" \
1856           --source-entity="%{MODULE/.//}.html#%{NAME}" \
1857           $$OPTGHC \
1858           $(HS_LIBTESTBUILT_SRCS)
1859
1860 .PHONY: TAGS
1861 TAGS: $(GENERATED_FILES)
1862         rm -f TAGS
1863         $(GHC) -e ":etags" -v0 \
1864           $(filter-out -O -Werror,$(HFLAGS)) \
1865           $(HS_NOCURL) $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
1866           $(HS_LIBTEST_SRCS)
1867         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
1868           -path './daemons/ganeti-*' -o -path './tools/*' -o \
1869           -path './qa/*.py' | \
1870           etags -l python -a -
1871
1872 .PHONY: coverage
1873 if WANT_HTOOLS
1874 coverage: py-coverage hs-coverage
1875 else
1876 coverage: py-coverage
1877 endif
1878
1879 .PHONY: py-coverage
1880 py-coverage: $(GENERATED_FILES) $(python_tests)
1881         @test -n "$(PYCOVERAGE)" || \
1882             { echo 'python-coverage' not found during configure; exit 1; }
1883         set -e; \
1884         COVERAGE=$(PYCOVERAGE) \
1885         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
1886         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
1887         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
1888         $(PLAIN_TESTS_ENVIRONMENT) \
1889         $(abs_top_srcdir)/autotools/gen-py-coverage \
1890         $(python_tests)
1891
1892 .PHONY: hs-coverage
1893 hs-coverage: $(haskell_tests) test/hs/hpc-htools test/hs/hpc-mon-collector
1894         rm -f *.tix
1895         $(MAKE) $(AM_MAKEFLAGS) hs-check
1896         @mkdir_p@ $(COVERAGE_HS_DIR)
1897         hpc sum --union $(HPCEXCL) \
1898           htest.tix hpc-htools.tix hpc-mon-collector.tix > coverage-hs.tix
1899         hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-hs.tix
1900         hpc report coverage-hs.tix
1901         $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
1902
1903 # Special "kind-of-QA" target for htools, needs special setup (all
1904 # tools compiled with -fhpc)
1905 .PHONY: live-test
1906 live-test: all
1907         set -e ; \
1908         cd src; \
1909         rm -f .hpc; $(LN_S) ../.hpc .hpc; \
1910         rm -f *.tix *.mix; \
1911         ./live-test.sh; \
1912         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:src/%=%)) \
1913           --output=live-test.tix ; \
1914         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
1915         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
1916           --srcdir=.. $(HPCEXCL) ; \
1917         hpc report --srcdir=.. live-test $(HPCEXCL)
1918
1919 commit-check: distcheck lint apidoc
1920
1921 .PHONY: gitignore-check
1922 gitignore-check:
1923         @if [ -n "`git status --short`" ]; then \
1924           echo "Git status is not clean!" 1>&2 ; \
1925           git status --short; \
1926           exit 1; \
1927         fi
1928
1929 # target to rebuild all man pages (both groff and html output)
1930 .PHONY: man
1931 man: $(man_MANS) $(manhtml)
1932
1933 # Target that builds all binaries (including those that are not
1934 # rebuilt except when running the tests)
1935 .PHONY: really-all
1936 really-all: all $(check_SCRIPTS) $(haskell_tests) $(HS_ALL_PROGS)
1937
1938 # we don't need the ancient implicit rules:
1939 %: %,v
1940 %: RCS/%,v
1941 %: RCS/%
1942 %: s.%
1943 %: SCCS/s.%
1944
1945 -include ./Makefile.local
1946
1947 # vim: set noet :